Loading...
Searching...
No Matches
juce::dsp::LookupTable< FloatType > Class Template Reference

## Detailed Description

template<typename FloatType>
class juce::dsp::LookupTable< FloatType >

Class for efficiently approximating expensive arithmetic operations.

The approximation is based on linear interpolation between pre-calculated values. The approximated function should be passed as a callable object to the constructor along with the number of data points to be pre-calculated. The accuracy of the approximation can be increased by using more points at the cost of a larger memory footprint.

Consider using LookupTableTransform as an easy-to-use alternative.

Example:

LookupTable<float> lut ([] (size_t i) { return std::sqrt ((float) i); }, 64);
auto outValue = lut[17];
juce::dsp::LookupTable::LookupTable
LookupTable()
Creates an uninitialised LookupTable object.

See also
  LookupTableTransform

The documentation for this class was generated from the following file:

- juce_dsp/maths/juce_LookupTable.h

## Public Member Functions

| LookupTable ()
| Creates an uninitialised LookupTable object.
| LookupTable (const std::function< FloatType(size_t)> &functionToApproximate, size_t numPointsToUse)
| Creates and initialises a LookupTable object.
void | initialise (const std::function< FloatType(size_t)> &functionToApproximate, size_t numPointsToUse)
| Initialises or changes the parameters of a LookupTable object.
FloatType | getUnchecked (FloatType index) const noexcept
| Calculates the approximated value for the given index without range checking.
FloatType | get (FloatType index) const noexcept
| Calculates the approximated value for the given index with range checking.
FloatType | operator[] (FloatType index) const noexcept
size_t | getNumPoints () const noexcept
| Returns the size of the LookupTable, i.e., the number of pre-calculated data points.
bool | isInitialised () const noexcept
| Returns true if the LookupTable is initialised and ready to be used.

## Constructors and Destructors

## LookupTable() [1/2]

template<typename FloatType>

juce::dsp::LookupTable< FloatType >::LookupTable | ( |  | ) |

Creates an uninitialised LookupTable object.

You need to call initialise() before using the object. Prefer using the non-default constructor instead.

See also
  initialise

## LookupTable() [2/2]

template<typename FloatType>

juce::dsp::LookupTable< FloatType >::LookupTable | ( | const std::function< FloatType(size_t)> & | functionToApproximate,
|  | size_t | numPointsToUse )

Creates and initialises a LookupTable object.

Parameters

  functionToApproximate | The function to be approximated. This should be a mapping from the integer range [0, numPointsToUse - 1].
  numPointsToUse | The number of pre-calculated values stored.

## Member Functions

## initialise()

template<typename FloatType>

void juce::dsp::LookupTable< FloatType >::initialise | ( | const std::function< FloatType(size_t)> & | functionToApproximate,
|  | size_t | numPointsToUse )

Initialises or changes the parameters of a LookupTable object.

This function can be used to change what function is approximated by an already constructed LookupTable along with the number of data points used. If the function to be approximated won't ever change, prefer using the non-default constructor.

Parameters

  functionToApproximate | The function to be approximated. This should be a mapping from the integer range [0, numPointsToUse - 1].
  numPointsToUse | The number of pre-calculated values stored.

## getUnchecked()

template<typename FloatType>

FloatType juce::dsp::LookupTable< FloatType >::getUnchecked | ( | FloatType | index | ) | const

inline noexcept

Calculates the approximated value for the given index without range checking.

Use this if you can guarantee that the index is non-negative and less than numPoints. Otherwise use get().

Parameters

  index | The approximation is calculated for this non-integer index.

Returns
  The approximated value at the given index.

See also
  get, operator[]

References getNumPoints(), isInitialised(), juce::isPositiveAndBelow(), jassert, juce::jmap(), and juce::truncatePositiveToUnsignedInt().

Referenced by get(), and operator[]().

## get()

template<typename FloatType>

FloatType juce::dsp::LookupTable< FloatType >::get | ( | FloatType | index | ) | const

inline noexcept

Calculates the approximated value for the given index with range checking.

This can be called with any input indices. If the provided index is out-of-range either the bottom or the top element of the LookupTable is returned.

If the index is guaranteed to be in range use the faster getUnchecked() instead.

Parameters

  index | The approximation is calculated for this non-integer index.

Returns
  The approximated value at the given index.

See also
  getUnchecked, operator[]

References getNumPoints(), and getUnchecked().

## operator[]()

template<typename FloatType>

FloatType juce::dsp::LookupTable< FloatType >::operator[] | ( | FloatType | index | ) | const

inline noexcept

See also
  getUnchecked

References getUnchecked().

## getNumPoints()

template<typename FloatType>

size_t juce::dsp::LookupTable< FloatType >::getNumPoints | ( |  | ) | const

inline noexcept

Returns the size of the LookupTable, i.e., the number of pre-calculated data points.

Referenced by get(), and getUnchecked().

## isInitialised()

template<typename FloatType>

bool juce::dsp::LookupTable< FloatType >::isInitialised | ( |  | ) | const

inline noexcept

Returns true if the LookupTable is initialised and ready to be used.

Referenced by getUnchecked().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited